// Tree-like

// draws a tree-like shape at the center of the artboard

// ### notice
// The tree is made with various width of lines.
// So please be careful about the setting of Scale Tool
// when you want to scale it.

// 2005.01.12
// 2006.07.19 clean the code, change the variable names to english.
//            Maybe there is still room for a rearrangement to the parameters.

// JavaScript Script for Adobe Illustrator CS
// by SATO Hiroyuki  http://park12.wakwak.com/~shp/lc/et/en_aics_script.html

// changes by ogebab: @@@@@@@@@

// == Settings =====================================

var grow = 2; // rate for growing
var bend = 2; // rate for bending
var branch = 4; // rate for branching
var thickness = 16; // starting value of the thickness of the trunk(branch)
var minThickness = 5; // minimum value of the thickness of the branches
var rate = 7; // rate for the thickness of the next branch
var trial = 500; // trail count to grow branches



var tre ;


//    @@@@@@@@@@@@@@@q
var t1  ="grow"             ;
var t2  ="bend"             ;
var t3  ="branch"           ;
var t4  ="thickness"        ;
var t5  ="minThinkn."       ;
var t6  ="rate"             ;
var t7  ="trial"            ;



function Point(x, y) {
    this.name = "_point";
    if (arguments.length == 1) { this.x = x[0]; this.y = x[1] };
    if (arguments.length == 2) { this.x = x; this.y = y};
	this.arr = [this.x , this.y]
}
Point.prototype.Dot=function (d){
	var ell=app.activeDocument.pathItems.ellipse(this.y + d/2 , this.x - d/2 ,d,d);
	ell.selected=false; return ell
}
Point.prototype.add=function(that){return new Point(this.x+that.x,this.y+that.y);};


try {activeDocument.swatches.getByName("leave")}catch(e){var black={c:75, m:0, y:100, k:0}, Sw=activeDocument.swatches.add(), neuSw=new CMYKColor();Sw.name="leave";neuSw.cyan=black.c;neuSw.magenta=black.m;neuSw.yellow=black.y;neuSw.black=black.k;Sw.color=neuSw;}
var col = activeDocument.swatches.getByName("leave").color ;
try{
	var sym=activeDocument.symbols.getByName("leave")
}catch(e){
	var sy = new Point(0,0) ;
	var sy2=sy.Dot(5);
	sy2.fillColor = col ;
	sy2.stroked = false ;
	
	var sym = app.activeDocument.symbols.add( sy2 ) ;
	sy2.remove();
	sym.name = "leave";

}

var w = new Window("dialog", "tree" );
w.frameLocation = [0,20];
w.alignChildren = "right"; 
w.G1 = w.add("group");w.G1.orientation = "row";
w.G2 = w.add("group");w.G2.orientation = "row";
w.G3 = w.add("group");w.G3.orientation = "row";
w.G4 = w.add("group");w.G4.orientation = "row";
w.G5 = w.add("group");w.G5.orientation = "row";
w.G6 = w.add("group");w.G6.orientation = "row";
w.G7 = w.add("group");w.G7.orientation = "row";
w.G8 = w.add("group");w.G8.orientation = "row";

w.B1 = w.add("button" , undefined, "tree" );

w.G1.sTex = w.G1.add("statictext", undefined , t1 ); 
w.G2.sTex = w.G2.add("statictext", undefined , t2 ); 
w.G3.sTex = w.G3.add("statictext", undefined , t3 ); 
w.G4.sTex = w.G4.add("statictext", undefined , t4 ); 
w.G5.sTex = w.G5.add("statictext", undefined , t5 ); 
w.G6.sTex = w.G6.add("statictext", undefined , t6 );
w.G7.sTex = w.G7.add("statictext", undefined , t7 );
// w.G8.sTex = w.G8.add("statictext", undefined , t8 );

w.G1.eTex =w.G1.add("slider", undefined, grow			, 1, 10 );
w.G2.eTex =w.G2.add("slider", undefined, bend			, 1, 10 );
w.G3.eTex =w.G3.add("slider", undefined, branch			, 1, 10 );
w.G4.eTex =w.G4.add("slider", undefined, thickness		, 5, 50 );
w.G5.eTex =w.G5.add("slider", undefined, minThickness	, 1, 10 );
w.G6.eTex =w.G6.add("slider", undefined, rate			, 1, 10 );
w.G7.eTex =w.G7.add("slider", undefined, trial			, 10, 1000 );
w.G8.eTex =w.G8.add("checkbox", undefined, "leave" );w.G8.eTex.value=true;

w.B1.onClick = function(){
	grow			= w.G1.eTex.value *1;
	bend			= w.G2.eTex.value *1;
	branch			= w.G3.eTex.value *1;
	thickness		= w.G4.eTex.value *1;
	minThickness	= w.G5.eTex.value *0.1;
	rate			= w.G6.eTex.value *0.1;
	trial			= w.G7.eTex.value *1;


	ver10 = version.indexOf('10') == 0;

	if(tre) tre.hidden = true;
	tre = makeTree();
	redraw()
}
w.show() ;
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

// define a growth unit for thickness of a branch
function def_growLen(thickness, minThickness) {
	return Math.max(Math.sqrt(thickness*2), minThickness*3);
}

// define a trial count for thickness of a branch
function def_branchTimes(thickness){ return Math.max(thickness*3, 20); }

// define maximum bending angle
function def_eda_kakudo(growLen){ return Math.PI / growLen / 2; }

var ver10 = version.indexOf('10') == 0;

// =============================================
function makeTree(){
	if (documents.length<1) return;
	var lay = activeDocument.activeLayer;
	if(lay.locked || !lay.visible){
		alert("Please unlock and show the active layer."); return;
	}

	var branchTimes = def_branchTimes(thickness);
	var growLen = def_growLen(thickness, minThickness);

	bend  += grow; branch += bend; grow /= branch; bend /= branch;

	// values for the position of the branches
	var branchLocs = [1,-1,0,-0.5,0.5];

	// =============================================
	var gr = lay.groupItems.add();
	var le = lay.groupItems.add();
	var tr = lay.groupItems.add();
	var branches = [];
	branches.push( [[0,0], [0,growLen], thickness]);

	var b, x, y, reserve, c, i, j, r, t, v;
	var newBranches, total, togglekey;

	for(var k=0; k<=trial; k++){
		if (branches.length<1) break;
		
		b = branches.shift();
		thickness = b.pop();
		x = b[1][0];
		y = b[1][1];
		reserve = 0;
		c = 1;

		// define the growing length anew
		branchTimes = def_branchTimes(thickness);
		growLen = def_growLen(thickness, minThickness);

		// grow/bend a branch until it branches
		for(j=0; j <= branchTimes; j++){
			r = Math.random();

			if (r < grow){
				reserve += growLen;
				
			} else if (r < bend){
				t = getRad(b[c-1],b[c]) + (Math.random()-0.5) * def_eda_kakudo(growLen);
				v = pointForAngle(t, growLen + reserve);
				// restrain the branch from turning to lower direction
				if (b[c][1] < b[c-1][1]) v[1] *= -0.5;
				x += v[0];
				y += v[1];
				reserve = 0;
				c++;
				b.push([x, y]);

			} else { // branch
				if (c < 5) continue; // doesn't branch if it's short yet
				break;
			}
		}

		// the following is a branching procedure
		if (thickness <= minThickness) continue;
		
		// define the thickness of branches to grow at random and make an array
		newBranches = [];
		total = 0;
		while(total < thickness){
			// define the thickness of the branch
			r = Math.random() * (thickness-minThickness) * rate + minThickness;
			total += r;
			newBranches.push(r);
		}
		newBranches.sort();
		newBranches.reverse(); // assign a place from thicker value

		t = Math.atan2(b[c][0] - b[c-1][0],
		b[c-1][1] - b[c][1]); // angle of the parent branch

		for(i=0; i<newBranches.length; i++) {
			togglekey = branchLocs[i%(branchLocs.length)];
			v = pointForAngle(t, (thickness - newBranches[i])/2*togglekey);
			branches.push( [b[c-1],
			[b[c][0] + v[0], b[c][1] + v[1]],
			newBranches[i]]);
		}

		// draw
		if (b.length > 3) {
			with(lay.pathItems.add()){
				setEntirePath(b);
				filled = false;
				stroked = true;
				strokeWidth = thickness;
				strokeCap = StrokeCap.BUTTENDCAP;
				strokeJoin = StrokeJoin.ROUNDENDJOIN;
				if(ver10){
					moveToBeginning(gr);
				} else {
					move(gr, ElementPlacement.PLACEATEND);
				}
				//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
				if(w.G8.eTex.value==true){
					var punkt = new Point(pathPoints[pathPoints.length-1].anchor);
					var symi = app.activeDocument.symbolItems.add( sym ) ;
					symi.position = punkt.add({ x:-5/2 , y: 5/2 }).arr ;
					symi.move(le, ElementPlacement.PLACEATBEGINNING);
				}
				//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			}
		}
	}
	gr.move(tr, ElementPlacement.PLACEATBEGINNING);
	le.move(tr, ElementPlacement.PLACEATBEGINNING);
	// translate group to the center of the artboard
	if(gr.pathItems.length>0){
		tr.translate(activeDocument.width/2, activeDocument.height/2);
	} else { tr.remove(); }
	return tr 
}

// ----------------------------------------------
function pointForAngle(t, m){
	return [Math.cos(t)*m, Math.sin(t)*m];
}
// ----------------------------------------------
function getRad(p1, p2) {
	return Math.atan2(p2[1] - p1[1], p2[0] - p1[0]);
}
// ------------------------------------------------
function normalize(p, o){
	var d = dist(p,o);
	return d==0 ? [0,0] : [(p[0]-o[0])/d, (p[1]-o[1])/d];
}
// ----------------------------------------------
// return the distance between p1 and p2
function dist(p1, p2) {
	return Math.sqrt(Math.pow(p1[0] - p2[0],2) + Math.pow(p1[1] - p2[1],2));
}
// ----------------------------------------------

